#ifndef TINYCDB_VERSION
#define TINYCDB_VERSION 0.2

typedef unsigned int cdbi_t; /*XXX should be at least 32 bits long */

/* common routines */
cdbi_t cdb_hash(const void *buf, cdbi_t len);
cdbi_t cdb_unpack(const unsigned char buf[4]);
void cdb_pack(cdbi_t num, unsigned char buf[4]);

struct cdb {
  int cdb_fd;			/* file descriptor */
  /* private members */
  cdbi_t cdb_fsize;		/* datafile size */
  const unsigned char *cdb_mem; /* mmap'ed file memory */
  cdbi_t cdb_vpos, cdb_vlen;	/* found data */
};

#define cdb_datapos(c) ((c)->cdb_vpos)
#define cdb_datalen(c) ((c)->cdb_vlen)
#define cdb_fileno(c) ((c)->cdb_fd)

int cdb_init(struct cdb *cdbp, int fd);
void cdb_free(struct cdb *cdbp);

int cdb_read(const struct cdb *cdbp, void *buf, unsigned len, cdbi_t pos);
int cdb_find(struct cdb *cdbp, const void *key, unsigned klen);

/* cdb_make */

struct cdb_make {
  int cdb_fd;			/* file descriptor */
  /* private */
  cdbi_t cdb_dpos;		/* data position so far */
  cdbi_t cdb_rcnt;		/* record count so far */
  char cdb_buf[4096];		/* write buffer */
  char *cdb_bpos;		/* current buf position */
  struct cdb_rl *cdb_rec[256];	/* list of arrays of record infos */
};

int cdb_make_start(struct cdb_make *cdbmp, int fd);
int cdb_make_add(struct cdb_make *cdbmp,
		 const void *key, cdbi_t klen,
		 const void *val, cdbi_t vlen);
int cdb_make_exists(struct cdb_make *cdbmp,
		    const void *key, cdbi_t klen);
int cdb_make_finish(struct cdb_make *cdbmp);

#endif /* include guard */
